﻿using System;
using Infragistics.Windows.DataPresenter;
using Infragistics.Windows;

namespace xamDataGridExtendedSaveCustomization
{
    public class CustomCalculator : SumSummaryCalculator
    {
        Double remaining;
        public Double amount { get; set; }

        public override void Aggregate(object dataValue, SummaryResult summaryResult, Record record)
        {
            remaining -= Convert.ToDouble(dataValue);
        }

        public override void BeginCalculation(SummaryResult summaryResult)
        {
            remaining = amount;
        }

        public override bool CanProcessDataType(Type dataType)
        {
            return Utilities.IsNumericType(dataType);
        }

        public override string Description
        {
            get
            {
                return "Custom Calculator";
            }
        }

        public override object EndCalculation(SummaryResult summaryResult)
        {
            return remaining;
        }

        public override string Name
        {
            get
            {
                return "CustomCalculator";
            }
        }

        public override string ApplyDefaultFormat(object summaryResultValue, SummaryResult context)
        {
            return string.Format("{0} {1} {2}", "Summary Result  ", "Remaining Quantity  ", summaryResultValue);
        }
    }
}
